﻿------------------------------------------------------------------------------
-- $Id$
------------------------------------------------------------------------------
--                            templates.lua
--
--    Copyright (C) 2014 jlongwell
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Lesser General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU Lesser General Public License
--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
--  This file is for use with clcInfo by abija.
--
--  abija has distributed clcInfo All Rights Reserved.  For more information
--  go to: http://wow.curseforge.com/addons/clctracker/
--
------------------------------------------------------------------------------
-- Author:
--      jlongwell (Health@Blackrock)
------------------------------------------------------------------------------
-- Description:
--   Templates for clcInfo_ArmsWarrior
--------------------------------------------------------------------------------
-- loader
if not clcInfo then return end
if not clcInfo_Warrior then return end

clcInfo.optionsCMLoaders[#(clcInfo.optionsCMLoaders) + 1] = function()
    -- don't load if class is wrong
    local _, englishClass = UnitClass("player")
    if englishClass ~= clcInfo_Warrior.CLASS then return end
    
    local mod = clcInfo_Options.templates
    local defs = mod.defs
    local format = string.format
    
    local spells = clcInfo_Warrior.spells

    local name
    
    --Icons-----------------------------------------------------------
    -- Generic Warrior -----------------------------------------------
    local basic_cds = clcInfo_Warrior.basic_cds
    -- get the localized names and make cd templates  
    for key, value in pairs(basic_cds) do
        name = GetSpellInfo(value)
        if not name then name = "Unknown Spell" end
        mod:Add("icons", defs.CLASS, name, format([[
        return IconSpell("%s")
        ]], name))
    end 
    

    --Rage
    name = RAGE
    mod:Add("bars", defs.CLASS, name, format([[
    local rage = UnitPower("player")
    return true, nil, 0,
    UnitPowerMax("player"), rage, nil, "Rage", nil, rage
    ]], name))  

   
    -- Priorities
    ----------------------------------------------------------------------------
    -- Arms Priorities
    local _, talent_tree_name = GetSpecializationInfo(1)
    mod:Add("icons", defs.CLASS_1, format("%s %s: %s", talent_tree_name,
    COMBATLOG_HIGHLIGHT_ABILITY, REFORGE_CURRENT), "return IconArmsCurrent()")
    mod:Add("icons", defs.CLASS_1, format("%s %s: %s", talent_tree_name,
    COMBATLOG_HIGHLIGHT_ABILITY, NEXT), "IconArmsNext()")
end